// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: regulatormodule/regulatormodule.proto

package openfmb.regulatormodule;

/**
 * <pre>
 * Using 61850 FSCC for regulator control
 * </pre>
 *
 * Protobuf type {@code regulatormodule.RegulatorControlFSCC}
 */
public final class RegulatorControlFSCC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:regulatormodule.RegulatorControlFSCC)
    RegulatorControlFSCCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use RegulatorControlFSCC.newBuilder() to construct.
  private RegulatorControlFSCC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private RegulatorControlFSCC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new RegulatorControlFSCC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlFSCC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlFSCC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.regulatormodule.RegulatorControlFSCC.class, openfmb.regulatormodule.RegulatorControlFSCC.Builder.class);
  }

  public static final int CONTROLFSCC_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlFSCC controlFSCC_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlFSCC field is set.
   */
  @java.lang.Override
  public boolean hasControlFSCC() {
    return controlFSCC_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlFSCC.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlFSCC getControlFSCC() {
    return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlFSCCOrBuilder getControlFSCCOrBuilder() {
    return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
  }

  public static final int REGULATORCONTROLSCHEDULEFSCH_FIELD_NUMBER = 2;
  private openfmb.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
   * @return Whether the regulatorControlScheduleFSCH field is set.
   */
  @java.lang.Override
  public boolean hasRegulatorControlScheduleFSCH() {
    return regulatorControlScheduleFSCH_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
   * @return The regulatorControlScheduleFSCH.
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControlScheduleFSCH getRegulatorControlScheduleFSCH() {
    return regulatorControlScheduleFSCH_ == null ? openfmb.regulatormodule.RegulatorControlScheduleFSCH.getDefaultInstance() : regulatorControlScheduleFSCH_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControlScheduleFSCHOrBuilder getRegulatorControlScheduleFSCHOrBuilder() {
    return regulatorControlScheduleFSCH_ == null ? openfmb.regulatormodule.RegulatorControlScheduleFSCH.getDefaultInstance() : regulatorControlScheduleFSCH_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlFSCC_ != null) {
      output.writeMessage(1, getControlFSCC());
    }
    if (regulatorControlScheduleFSCH_ != null) {
      output.writeMessage(2, getRegulatorControlScheduleFSCH());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlFSCC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlFSCC());
    }
    if (regulatorControlScheduleFSCH_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getRegulatorControlScheduleFSCH());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.regulatormodule.RegulatorControlFSCC)) {
      return super.equals(obj);
    }
    openfmb.regulatormodule.RegulatorControlFSCC other = (openfmb.regulatormodule.RegulatorControlFSCC) obj;

    if (hasControlFSCC() != other.hasControlFSCC()) return false;
    if (hasControlFSCC()) {
      if (!getControlFSCC()
          .equals(other.getControlFSCC())) return false;
    }
    if (hasRegulatorControlScheduleFSCH() != other.hasRegulatorControlScheduleFSCH()) return false;
    if (hasRegulatorControlScheduleFSCH()) {
      if (!getRegulatorControlScheduleFSCH()
          .equals(other.getRegulatorControlScheduleFSCH())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlFSCC()) {
      hash = (37 * hash) + CONTROLFSCC_FIELD_NUMBER;
      hash = (53 * hash) + getControlFSCC().hashCode();
    }
    if (hasRegulatorControlScheduleFSCH()) {
      hash = (37 * hash) + REGULATORCONTROLSCHEDULEFSCH_FIELD_NUMBER;
      hash = (53 * hash) + getRegulatorControlScheduleFSCH().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlFSCC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.regulatormodule.RegulatorControlFSCC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Using 61850 FSCC for regulator control
   * </pre>
   *
   * Protobuf type {@code regulatormodule.RegulatorControlFSCC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:regulatormodule.RegulatorControlFSCC)
      openfmb.regulatormodule.RegulatorControlFSCCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlFSCC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlFSCC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.regulatormodule.RegulatorControlFSCC.class, openfmb.regulatormodule.RegulatorControlFSCC.Builder.class);
    }

    // Construct using openfmb.regulatormodule.RegulatorControlFSCC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlFSCC_ = null;
      if (controlFSCCBuilder_ != null) {
        controlFSCCBuilder_.dispose();
        controlFSCCBuilder_ = null;
      }
      regulatorControlScheduleFSCH_ = null;
      if (regulatorControlScheduleFSCHBuilder_ != null) {
        regulatorControlScheduleFSCHBuilder_.dispose();
        regulatorControlScheduleFSCHBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlFSCC_descriptor;
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlFSCC getDefaultInstanceForType() {
      return openfmb.regulatormodule.RegulatorControlFSCC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlFSCC build() {
      openfmb.regulatormodule.RegulatorControlFSCC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlFSCC buildPartial() {
      openfmb.regulatormodule.RegulatorControlFSCC result = new openfmb.regulatormodule.RegulatorControlFSCC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.regulatormodule.RegulatorControlFSCC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlFSCC_ = controlFSCCBuilder_ == null
            ? controlFSCC_
            : controlFSCCBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.regulatorControlScheduleFSCH_ = regulatorControlScheduleFSCHBuilder_ == null
            ? regulatorControlScheduleFSCH_
            : regulatorControlScheduleFSCHBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.regulatormodule.RegulatorControlFSCC) {
        return mergeFrom((openfmb.regulatormodule.RegulatorControlFSCC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.regulatormodule.RegulatorControlFSCC other) {
      if (other == openfmb.regulatormodule.RegulatorControlFSCC.getDefaultInstance()) return this;
      if (other.hasControlFSCC()) {
        mergeControlFSCC(other.getControlFSCC());
      }
      if (other.hasRegulatorControlScheduleFSCH()) {
        mergeRegulatorControlScheduleFSCH(other.getRegulatorControlScheduleFSCH());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlFSCCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getRegulatorControlScheduleFSCHFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlFSCC controlFSCC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder> controlFSCCBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlFSCC field is set.
     */
    public boolean hasControlFSCC() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlFSCC.
     */
    public openfmb.commonmodule.ControlFSCC getControlFSCC() {
      if (controlFSCCBuilder_ == null) {
        return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
      } else {
        return controlFSCCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlFSCC(openfmb.commonmodule.ControlFSCC value) {
      if (controlFSCCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlFSCC_ = value;
      } else {
        controlFSCCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlFSCC(
        openfmb.commonmodule.ControlFSCC.Builder builderForValue) {
      if (controlFSCCBuilder_ == null) {
        controlFSCC_ = builderForValue.build();
      } else {
        controlFSCCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlFSCC(openfmb.commonmodule.ControlFSCC value) {
      if (controlFSCCBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlFSCC_ != null &&
          controlFSCC_ != openfmb.commonmodule.ControlFSCC.getDefaultInstance()) {
          getControlFSCCBuilder().mergeFrom(value);
        } else {
          controlFSCC_ = value;
        }
      } else {
        controlFSCCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlFSCC() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlFSCC_ = null;
      if (controlFSCCBuilder_ != null) {
        controlFSCCBuilder_.dispose();
        controlFSCCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlFSCC.Builder getControlFSCCBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlFSCCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlFSCCOrBuilder getControlFSCCOrBuilder() {
      if (controlFSCCBuilder_ != null) {
        return controlFSCCBuilder_.getMessageOrBuilder();
      } else {
        return controlFSCC_ == null ?
            openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder> 
        getControlFSCCFieldBuilder() {
      if (controlFSCCBuilder_ == null) {
        controlFSCCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder>(
                getControlFSCC(),
                getParentForChildren(),
                isClean());
        controlFSCC_ = null;
      }
      return controlFSCCBuilder_;
    }

    private openfmb.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorControlScheduleFSCH, openfmb.regulatormodule.RegulatorControlScheduleFSCH.Builder, openfmb.regulatormodule.RegulatorControlScheduleFSCHOrBuilder> regulatorControlScheduleFSCHBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     * @return Whether the regulatorControlScheduleFSCH field is set.
     */
    public boolean hasRegulatorControlScheduleFSCH() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     * @return The regulatorControlScheduleFSCH.
     */
    public openfmb.regulatormodule.RegulatorControlScheduleFSCH getRegulatorControlScheduleFSCH() {
      if (regulatorControlScheduleFSCHBuilder_ == null) {
        return regulatorControlScheduleFSCH_ == null ? openfmb.regulatormodule.RegulatorControlScheduleFSCH.getDefaultInstance() : regulatorControlScheduleFSCH_;
      } else {
        return regulatorControlScheduleFSCHBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public Builder setRegulatorControlScheduleFSCH(openfmb.regulatormodule.RegulatorControlScheduleFSCH value) {
      if (regulatorControlScheduleFSCHBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        regulatorControlScheduleFSCH_ = value;
      } else {
        regulatorControlScheduleFSCHBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public Builder setRegulatorControlScheduleFSCH(
        openfmb.regulatormodule.RegulatorControlScheduleFSCH.Builder builderForValue) {
      if (regulatorControlScheduleFSCHBuilder_ == null) {
        regulatorControlScheduleFSCH_ = builderForValue.build();
      } else {
        regulatorControlScheduleFSCHBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public Builder mergeRegulatorControlScheduleFSCH(openfmb.regulatormodule.RegulatorControlScheduleFSCH value) {
      if (regulatorControlScheduleFSCHBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          regulatorControlScheduleFSCH_ != null &&
          regulatorControlScheduleFSCH_ != openfmb.regulatormodule.RegulatorControlScheduleFSCH.getDefaultInstance()) {
          getRegulatorControlScheduleFSCHBuilder().mergeFrom(value);
        } else {
          regulatorControlScheduleFSCH_ = value;
        }
      } else {
        regulatorControlScheduleFSCHBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public Builder clearRegulatorControlScheduleFSCH() {
      bitField0_ = (bitField0_ & ~0x00000002);
      regulatorControlScheduleFSCH_ = null;
      if (regulatorControlScheduleFSCHBuilder_ != null) {
        regulatorControlScheduleFSCHBuilder_.dispose();
        regulatorControlScheduleFSCHBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public openfmb.regulatormodule.RegulatorControlScheduleFSCH.Builder getRegulatorControlScheduleFSCHBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getRegulatorControlScheduleFSCHFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    public openfmb.regulatormodule.RegulatorControlScheduleFSCHOrBuilder getRegulatorControlScheduleFSCHOrBuilder() {
      if (regulatorControlScheduleFSCHBuilder_ != null) {
        return regulatorControlScheduleFSCHBuilder_.getMessageOrBuilder();
      } else {
        return regulatorControlScheduleFSCH_ == null ?
            openfmb.regulatormodule.RegulatorControlScheduleFSCH.getDefaultInstance() : regulatorControlScheduleFSCH_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControlScheduleFSCH regulatorControlScheduleFSCH = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorControlScheduleFSCH, openfmb.regulatormodule.RegulatorControlScheduleFSCH.Builder, openfmb.regulatormodule.RegulatorControlScheduleFSCHOrBuilder> 
        getRegulatorControlScheduleFSCHFieldBuilder() {
      if (regulatorControlScheduleFSCHBuilder_ == null) {
        regulatorControlScheduleFSCHBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.regulatormodule.RegulatorControlScheduleFSCH, openfmb.regulatormodule.RegulatorControlScheduleFSCH.Builder, openfmb.regulatormodule.RegulatorControlScheduleFSCHOrBuilder>(
                getRegulatorControlScheduleFSCH(),
                getParentForChildren(),
                isClean());
        regulatorControlScheduleFSCH_ = null;
      }
      return regulatorControlScheduleFSCHBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:regulatormodule.RegulatorControlFSCC)
  }

  // @@protoc_insertion_point(class_scope:regulatormodule.RegulatorControlFSCC)
  private static final openfmb.regulatormodule.RegulatorControlFSCC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.regulatormodule.RegulatorControlFSCC();
  }

  public static openfmb.regulatormodule.RegulatorControlFSCC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<RegulatorControlFSCC>
      PARSER = new com.google.protobuf.AbstractParser<RegulatorControlFSCC>() {
    @java.lang.Override
    public RegulatorControlFSCC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<RegulatorControlFSCC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<RegulatorControlFSCC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControlFSCC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

